//THIS IS FOR ATTINY85 ONLY!
#include <SoftwareSerial.h>  //Software Serial Port

//vol cntrl pins
#define VOL_A 0
#define VOL_B 1

//buttons pin
#define BTNS A1

//bluetooth pins
#define RxD 3
#define TxD 4

//bluetooth connection
SoftwareSerial blueToothSerial(RxD,TxD);

//signal segment timing (ms)
#define SIGNAL_DELAY 80

//it takes ~64 cycles to take the volume from min to max

void setup() {
  //init buttons
  pinMode(BTNS, INPUT);
  
  //init volume outputs
  pinMode(VOL_A, OUTPUT);
  pinMode(VOL_B, OUTPUT);
  digitalWrite(VOL_A, HIGH);
  digitalWrite(VOL_B, HIGH);

  //init BT
  pinMode(RxD, INPUT);
  pinMode(TxD, OUTPUT);
  setupBlueToothConnection();
}

void loop() {
  //read buttons state & send appropriate signals to the stereo
  int btnState = analogRead(BTNS);
  if(btnState < 300) {
    volDown();
  } else {
    if(btnState < 700) {
      volUp();
    }
  }

  //read remote commands over BT & send appropriate signals to the stereo
  char recvChar;
  while (blueToothSerial.available() > 0 ) {
    recvChar = blueToothSerial.read();
    if (recvChar == '1') {
      volUp();
    } else {
      if (recvChar == '2') {
        volDown();
      }
    }
  }
}

void volDown()
{
  digitalWrite(VOL_B, LOW);
  delay(SIGNAL_DELAY);
  digitalWrite(VOL_B, HIGH);
  digitalWrite(VOL_A, LOW);
  delay(SIGNAL_DELAY);
  digitalWrite(VOL_A, HIGH);
  delay(SIGNAL_DELAY);
}

void volUp()
{
  digitalWrite(VOL_A, LOW);
  delay(SIGNAL_DELAY);
  digitalWrite(VOL_A, HIGH);
  digitalWrite(VOL_B, LOW);
  delay(SIGNAL_DELAY);
  digitalWrite(VOL_B, HIGH);
  delay(SIGNAL_DELAY);
}
 
void setupBlueToothConnection()
{
  blueToothSerial.begin(9600); //using the default baud rate of HC-06
  blueToothSerial.print("AT+NAMEdupa1"); //set the name - in fact it would be enough to do it just once, also a reset is needed after the change

  delay(2000); //a delay just to make sure that the setup is completed
  blueToothSerial.flush();
}
